<template>
    <section>
        <div class="container">
            <div class="row">
            <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                    <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                </div>
                <h2 class="text-center">Asignación de Materias</h2>
            </div>
        </div>
        <div class="container">
        <!-- CARD ASIGNACIONES -->
        <div class="float-right col-6">
            <div class="card text-center">
                <div class="card-header">
                    <h4><strong>Asignación de Materias a Carreras</strong></h4>
                </div>
                <div class="card-body">
                    <!-- alerta por si no existen -->
                     <div class="row shadow" style="border-radius: 5px">
                        <div v-if="asginaciones.length === 0">
                            <div class="alert alert-danger" role="alert" v-if="asginaciones.length === 0">
                                <h2 class="lead">No se cuenta con asginaciones registradss</h2>
                            </div>
                        </div>
                    </div>
                    <!-- fin de alerta -->
                    <!-- Inicio tabla -->
                    <div class="row align-items-start">
                        <b-button class="ml-3 mb-2" variant="primary" size="lg" id="show-btn" @click="showModal('moda')" v-b-tooltip.hover title="Registro nuevo" ><i class="material-icons">add_box</i></b-button>
                    </div>
                        <table v-show="asginaciones.length > 0" class="table table-hover table-light">
                            <thead>
                                <tr style="background-color: #019979">
                                    <!-- <th scope="col">#</th> -->
                                    <th scope="col" class="text-white lead">Carrrea</th>
                                    <th scope="col" class="text-white lead">Materia</th>
                                    <th scope="col" class="text-white lead">Acciones</th>

                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(asginacion, index) in asginaciones" :key="index" class="table-light lead">
                                    <td>{{asginacion.nombreCarrera}}</td>
                                    <td>{{asginacion.nombreMateria}}</td>
                                    <td>
                                        <b-button v-show="asginacion.nombreMateria != 'Matemáticas'"  v-b-tooltip.hover title="Modificar información" variant="warning" id="show-btn" @click="showModal('modal-modificarA'); llenarObjAsignacion(asginacion)"><i class="material-icons">create</i></b-button>
                                        <b-button v-show="asginacion.nombreMateria == 'Matemáticas'" variant="secondary" id="show-btn" ><i class="material-icons">create</i></b-button>
                                        <b-button variant="danger" id="show-btn" @click="eliminarAsignacion(asginacion.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    <!-- fin tabla -->
                </div>
            </div>
        </div>
        <!-- CARD MATERIAS  -->
        <div class="float-right col-6">
            <div class="card text-center">
                <div class="card-header">
                    <h4><strong>Materias</strong></h4>
                </div>
                <div class="card-body">
                    <!-- alerta por si no existen -->
                     <div class="row shadow" style="border-radius: 5px">
                        <div v-if="materias.length === 0">
                            <div class="alert alert-danger" role="alert" v-if="listasRegistro.response.listaMaterias.length === 0">
                                <h2 class="lead">No se cuenta con materias registradas</h2>
                            </div>
                        </div>
                    </div>
                    <!-- fin de alerta -->
                    <!-- Inicio tabla -->
                    <div class="row align-items-start">
                        <b-button class="ml-3 mb-2" variant="primary" size="lg" id="show-btn" v-b-tooltip.hover title="Registro nuevo" @click="showModal('modal-materia')"><i class="material-icons">add_box</i></b-button>
                    </div>
                        <table v-show="materias.length > 0" class="table table-hover table-light">
                            <thead>
                                <tr style="background-color: #019979">
                                    <!-- <th scope="col">#</th> -->
                                    <th scope="col" class="text-white lead">Materia</th>
                                    <!-- <th scope="col" class="text-white lead">Materia</th> -->
                                    <th scope="col" class="text-white lead">Acciones</th>

                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(materia, index) in materias" :key="index" class="table-light lead">
                                    <!-- <td>{{asginacion.nombreCarrera}}</td> -->
                                    <td>{{materia.nombreMateria}}</td>
                                    <td>
                                        <b-button variant="warning" style="margin-right:20px;" v-b-tooltip.hover title="Modificar información" id="show-btn" @click="showModal('modal-modificar-materia'); llenarObjMateria(materia)"><i class="material-icons">create</i></b-button>
                                        <b-button variant="danger" v-b-tooltip.hover title="Eliminar registro" id="show-btn" @click="eliminarMateria(materia.id)"><i class="material-icons">delete</i></b-button>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    <!-- fin tabla -->
                </div>
            </div>
        </div>
    </div>
<!-- MODAL REGISTRO Materia -->
    <b-modal ref="modal-materia" hide-footer title="Registrar Materia">
        <div class="d-block text-left">
            <h3></h3>
            <form @submit="registrarMateria">
                <div class="form-group">
                    <label for="formGroupExampleInput">Nombre materia</label>
                    <input type="text" class="form-control" placeholder="Programación" v-model="nombreMateria" required>
                </div>
                <b-button type="submit" block variant="outline-success">Registrar</b-button>
            </form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-materia')">Cancelar</b-button>
    </b-modal>
<!-- MODAL MODIFICAR MATERIA -->
    <b-modal ref="modal-modificar-materia" hide-footer title="Modificar Materia">
        <div class="d-block text-left">
            <h3></h3>
            <form @submit="modificarMateria">
                <div class="form-group">
                    <label for="formGroupExampleInput">Nombre materia</label>
                    <input type="text" class="form-control" placeholder="Programación" v-model="objMateria.nombreMateria">
                </div>
                <b-button type="submit" block variant="outline-success">Modificar</b-button>
            </form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificar-materia')">Cancelar</b-button>
    </b-modal>
<!-- MODAL REGISTRO -->
         <b-modal ref="moda" hide-footer title="Nueva Asignación">
                    <div class="d-block text-left">
                        <!-- <h3>Hello From My Modal!</h3> -->
                        <form @submit="registrarAsignacion">
                            <div class="row form-group">
                                <div class="col">
                                <label for>Materia</label>
                                <b-form-select v-model="idMateria" class="form-control" required>
                                    <option
                                    v-for="materia in materias"
                                    :key="materia.id"
                                    :value="materia.id">
                                    {{materia.nombreMateria}}
                                    </option>
                                </b-form-select>
                                </div>
                                <div class="col">
                                <label for>Carrera</label>
                                <b-form-select v-model="idCarrera" class="form-control" required>
                                    <option
                                    v-for="carrera in listasRegistro.response.listaCarreras"
                                    :key="carrera.id"
                                    :value="carrera.id">
                                    {{carrera.nombreCarrera}}
                                    </option>
                                </b-form-select>
                                </div>
                            </div>
                            <b-button  type="submit" block variant="outline-success">Asignar</b-button>
                        </form>
                    </div>
                <b-button class="mt-3" variant="outline-danger" block @click="hideModal('moda')">Cerrar</b-button>
        </b-modal>
<!-- MODAL MODIFICAR ASIGNACIÓN -->
        <b-modal ref="modal-modificarA" hide-footer title="Modificar Asignación">
            <div class="d-block text-left">
                <form @submit="modificarAsignacion">
                    <div class="row form-group">
                        <div class="col">
                            <label for>Materia</label>
                            <select v-model="objAsignacon.idMateria" class="form-control">
                                <option v-for="materia in listasRegistro.response.listaMaterias" :key="materia.id" :value="materia.id">
                                    {{materia.nombreMateria}}
                                </option>
                            </select>
                        </div>
                        <div class="col">
                            <label for>Carrera</label>
                            <select v-model="objAsignacon.idCarrera" class="form-control">
                                <option v-for="carrera in listasRegistro.response.listaCarreras" :key="carrera.id" :value="carrera.id">
                                    {{carrera.nombreCarrera}}
                                </option>
                            </select>
                        </div>
                    </div>
                    <b-button type="submit" block variant="outline-success"> Modificar</b-button>
                </form>
                <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificarA')">Cancelar</b-button>
            </div>
        </b-modal>
        </div>
    </section>
</template>

<script>
import axios from 'axios'
import {server} from '../../store'
import { functions } from '../../functionsGolbals'

export default {
    mixins: [functions],
    data(){
        return{
            user:[],
            output:null,
            asginaciones:[],
            idMateria:null,
            idCarrera:null,
            listasRegistro: [],
            objAsignacon:[],
            nombreMateria:null,
            materias:[],
            objMateria:[]
        }
    },
    mounted(){
        if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
        }else{
          this.user = JSON.parse(localStorage.getItem('usuario'));
        }
        this.obtenerListas();
        this.obtenerAsignaciones();
        this.obtenerMaterias();
    },
    methods:{
        obtenerMaterias(){
            axios
                .get(`${server.baseURL}/api/materias/lista`)
                .then(data => (this.materias = data.data));
        },
        llenarObjAsignacion: function (asignacion) {
            this.objAsignacon = asignacion
        },
        llenarObjMateria: function (materia) {
            this.objMateria = materia
        },
        obtenerListas(){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/materia-carrera/listasParaRegistro`, {
                division:{
                    id: this.user.divicionTrabajadorId
                }
            })
            .then(function (response) {
                currentObj.listasRegistro = response.data;
            })
            .catch(function (error) {
                currentObj.listasRegistro = error;
            });
        },
        obtenerAsignaciones(){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/materia-carrera/lista`, {
                division:{
                    id: this.user.divicionTrabajadorId,
                }
            })
            .then(function (response) {
                currentObj.asginaciones = response.data;
            })
            .catch(function (error) {
                currentObj.asginaciones = error;
            });
        },
        registrarAsignacion(e) {
        e.preventDefault();
        let currentObj = this;
            axios.post(`${server.baseURL}/api/materia-carrera/registro`, {
                registro:{
                    idMateria: this.idMateria,
                    idCarera: this.idCarrera,
                }
            })
            .then(function (response) {
                currentObj.output = response.data;
                currentObj.obtenerAsignaciones();
                currentObj.hideModal('moda');
                currentObj.alertSuccess(currentObj.output.response.message);  
            })
            .catch(function (error) {
                currentObj.output = error;
                currentObj.hideModal('moda');  
                currentObj.obtenerAsignaciones();
                currentObj.alertError(currentObj.output.response.message);
            });
        },
        registrarMateria(e) {
        e.preventDefault();
        let currentObj = this;
            axios.post(`${server.baseURL}/api/materias/registro`, {
                registro:{
                    nombreMateria: this.nombreMateria,
                }
            })
            .then(function (response) {
                currentObj.output = response.data;
                currentObj.obtenerMaterias();
                currentObj.hideModal('modal-materia');
                currentObj.alertSuccess(currentObj.output.response.message);  
            })
            .catch(function (error) {
                currentObj.output = error;
                currentObj.hideModal('modal-materia');  
                currentObj.obtenerMaterias();
                currentObj.alertError(currentObj.output.response.message);
            });
        },
        modificarAsignacion(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/materia-carrera/modificar`, {
                    modificar: {
                        id: this.objAsignacon.id,
                        idMateria: this.objAsignacon.idMateria,
                        idCarera: this.objAsignacon.idCarrera
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        modificarMateria(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/materias/modificar`, {
                    modificar: {
                        id: this.objMateria.id,
                        nombreMateria: this.objMateria.nombreMateria,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerMaterias();
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificar-materia');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerMaterias();
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificar-materia');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        goBack(){
            window.history.go(-1);
        },
        eliminarMateria(id){
          let currentObj = this;
            axios.post(`${server.baseURL}/api/materias/eliminar`, {
                    eliminar: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerMaterias();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        eliminarAsignacion(id){
          let currentObj = this;
            axios.post(`${server.baseURL}/api/materia-carrera/eliminar`, {
                    materiacarrera: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        }
    }
    }

</script>